main()
{
	maps\_load::main();
	maps\_treadfx::main("night");
//	maps\pathfinder_anim::main();
//	maps\pathfinder_anim::props();
//	maps\pathfinder_fx::main();
//	maps\_truck::main();

	precacheItem("THOMPSON");
	precacheItem("COLT");
	character\foley::precache();
	character\Airborne3b_thompson::precache();
	character\Airborne_scripted_pathfinder::precache();
	precacheModel("xmodel/c47");
	precacheModel("xmodel/eureka_beacon");
	precacheModel("xmodel/chessgame_animrig");
	precacheModel("xmodel/holophane_lamp");
	precacheModel("xmodel/piss_sequence_gunpose");
	precacheModel("xmodel/chessgame_animnode");
	precacheModel("xmodel/chessgame_animrig");
	precacheModel("xmodel/parachute_flat_A");
	

	level.ambient_track ["before battle"] = "ambient_pathfinder_quiet";
	level.ambient_track ["during battle"] = "ambient_pathfinder";
	thread maps\_utility::set_ambient("before battle");

        thread intro_screen();		
	thread objectives();
        thread music();

}

//germanRadio (radio)
//{
//	radio endon ("stop radio sound");
//	while (1)
//	{
//		radio playloopsound ("german_radio_pathfinder", "sounddone");
//		radio waittill ("sounddone");
//	}
//}

intro_screen()
{
       precacheString(&"MAP01_INTRO_TEST_PLACE");
       precacheString(&"MAP01_INTRO_TEST_DATE");
       precacheString(&"MAP01_INTRO_TEST_TIME");
       maps\_introscreen::introscreen(&"MAP01_INTRO_TEST_PLACE", &"MAP01_INTRO_TEST_DATE", &"MAP01_INTRO_TEST_TIME");


}

music()
{
	musicplay("powcamp_ramgate");
        wait 34;
        musicplay("redsquare_dark_loop");		
}


objectives ()
{
	
	legbag = getEnt("legbag","targetname");
 	
 	objective_add(1, "active", &"MAP01_OBJ1",legbag.origin);
	objective_current(1);

	trigger = getent ("legbag_trigger", "targetname");
	trigger setHintString(&"MAP01_LEGBAG"); // + binding
	trigger waittill ("trigger");
	org = legbag.origin;
	legbag delete();
	trigger delete();
	maps\_utility::keyHintPrint(&"MAP01_OBJECTIVEHINT", getKeyBinding("+scores"));
	objective_state(1, "done");
//	maps\_utility::playSoundinSpace ("PU_leg_bag", org);
//      thread tankReplacesObjective();
        thread field();
}


tankReplacesObjective()
{
        objective_add(2, "active", &"MAP01_OBJ2", getent ("auto100","targetname").origin);
	objective_current(2);
        objective_string(2, &"MAP01_OBJ2");
        nSniper endon ("death");
        nSniper = getent("auto100","targetname");
        thread field();
                      
}

field() 
{
//        nSniper waittill("death");
//        objective_state(2, "done");
        objective_add(3, "current", &"MAP01_OBJ3", getent("end_level","targetname").origin);
        objective_add(3, "active", &"MAP01_OBJ3", (2581, -2681, 0));
	objective_current(3);
        objective_string(3, &"MAP01_OBJ3");
	trigger waittill ("trigger");
	getent ("end_level","targetname") thread endlevel();
     
}

endlevel()
{
	self waittill ("trigger");
        objective_state(3, "done");
//	changelevel("training", 0, false, false);
	missionSuccess ("map1", true);
}
	