/**************************************************************************
Level: 		Base1
Campaign: 	Soviet
Objectives: 	   .
		
***************************************************************************/

#using_animtree("generic_human");
main()
{
	setExpFog (.000162, .78, .79, .80, 0);
        maps\_load::main();
        maps\_treadfx::main("night");
        maps\_flak::main();
        maps\_vehiclechase::main();

        
	precacheModel("xmodel/head_blane");  //head for script dieing models
	precacheModel("xmodel/ammo_panzerfaust_box2");
	precacheModel("xmodel/weapon_panzerfaust");


	//Set Ambient Tracks
	level.ambient_track ["inside"] = "ambient_training1_int";
	level.ambient_track ["outside"] = "ambient_training1_ext";
	thread maps\_utility::set_ambient("outside"); 

        
	level.campaign = "american";

        end_level = getent ("end_level","targetname"); 
        
        thread alarm_sound();
        thread music();
        thread tankReplacesObjective();
       
       
}
	

tankReplacesObjective ()
{
        objective_add(1, "active", &"MAP1_OBJ1", getent ("attack","targetname").origin);
	objective_current(1);
        objective_string(1, &"MAP1_OBJ1");
        nSniper endon ("death");
        nSniper = getent("attack","targetname");
        thread field_sniper_stance(nSniper);
                      
}

field_sniper_stance(nSniper)
{
	nSniper waittill("death");
        objective_state(1, "done");
        objective_add(5, "current", &"MAP1_OBJ5", getent("end_level","targetname").origin);
        objective_add(5, "active", &"MAP1_OBJ5", (2550, -2687, 0));
	objective_current(5);
        objective_string(5, &"MAP1_OBJ5");
	trigger waittill ("trigger");
	getent ("end_level","targetname") thread endlevel();
     
}


alarm_sound()
{
	wait 4; //soft wait

	alarms = getentarray ("alarm_sound", "targetname");
	for (i=0;i<alarms.size;i++)
	{
		alarms[i] playloopsound("air_raid_siren");
	}
}



music()
{
	musicplay("redsquare_dark_loop");	
}


endlevel()
{
	self waittill ("trigger");
        objective_state(5, "done");
//	changelevel("training1", 0, false, false);
	missionSuccess ("map2", true);
}



 
